package org.jeecg.common.util;

public enum StatusCode {
    /**
     * 0   请求成功
     * -101 参数异常
     * -102 服务器异常
     * -103 数据不存在
     * -104 渠道不存在
     * -105 规则尚未配置
     * -106 规则为空
     * -107 同盾数据为空
     * -108 模型服务异常
     * -109 深度搜索服务异常
     * -201 探针数据为空
     */
    COMMON_SUCCESS("success", 0, true),
    COMMON_PARAM_ERROR("参数异常", -1, false),
    BYTEDANCE_VIDEO_UPLOAD_FAIL("今日头条视频文件上传失败", -201, false),
    IMAGE_NUMBER_SHORTAGE("今日头条图片文件上传失败", -202, false),
    BYTEDANCE_IMAGE_UPLOAD_FAIL("今日头条图片文件上传失败", -203, false),
    TEMPLATE_NAME_HAS_EXIST("模板名称已存在", -204, false),
    TEMPLATE_NAME_IS_NULL("模板名称为空", -205, false),
    COMMON_SERVER_ERROR("server error", -102, false),
    COMMON_DATA_HAS_EXIST_ERROR("data has exist", -103, false),
    COMMON_CHANNEL_NOT_EXIST_ERROR("channel not exist", -104, false),
    COMMON_RULEENGINE_HAS_NOT_CONFIGURED_ERROR("ruleEngine has not configured", -105, false),
    COMMON_RULE_PACKAGE_IS_NULL_ERROR("rulepackage is null", -106, false),
    COMMON_TONGDUN_DATA_IS_NULL_ERROR("tongdun data is null", -107, false),
    COMMON_MODEL_SERVICE_ERROR("model service error", -108, false),
    COMMON_DEEPSEARCH_ERROR("deep search error", -109, false),
    COMMON_APPLICATION_MOBILE_IS_NULL_ERROR("application mobile is null", -110, false),
    COMMON_TANZHEN_DATA_IS_NULL_ERROR("tanzhen data is null", -201, false),
    COMMON_RULE_ERROR_APPLICATION_IS_NULL("there is no error application", -202, false);
    private String desc;
    private int code;
    private boolean flag;

    StatusCode(String desc, int code, boolean flag) {
        this.desc = desc;
        this.code = code;
        this.flag = flag;
    }

    public static String getDesc(int code) {
        for (StatusCode error : StatusCode.values()) {
            if (error.getCode() == code) {
                return error.getDesc();
            }
        }
        return null;
    }

    public static Boolean getFlag(int code) {
        for (StatusCode error : StatusCode.values()) {
            if (error.getCode() == code) {
                return error.getFlag();
            }
        }
        return null;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public boolean getFlag() {
        return flag;
    }

    public void setFlag(boolean flag) {
        this.flag = flag;
    }

}
