package org.jeecg.modules.ctop.controller;

import org.jeecg.modules.ctop.service.IBindAccountAuthService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Map;
import java.util.UUID;

@Controller
@RequestMapping("/auth")
public class AuthController {
    private static final Logger logger = LoggerFactory.getLogger(AuthController.class);

    @Autowired
    private IBindAccountAuthService bindAccountAuthService;


    @RequestMapping("/begin")
    public String authBegin(HttpServletRequest request,
                            HttpServletResponse response,
                            @RequestParam("auth_type") String authType) {
        try {
            String codeUrl = "";
            switch (authType) {
                case "bytedance":
                    codeUrl = bindAccountAuthService.getByteDanceCodeUrl(UUID.randomUUID().toString());
                    System.out.println(codeUrl);
                    return "redirect:" + codeUrl;
                case "kuaishou":
                    codeUrl = bindAccountAuthService.getKuaishouCodeUrl(UUID.randomUUID().toString());
                    System.out.println(codeUrl);
                    return "redirect:" + codeUrl;
                default:
                    System.out.println("");

            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return "auth_error";
    }


    @GetMapping("bytedance/refreshtoken")
    @ResponseBody
    public Map<String, Object> refreshToken(String accountId) {
        return null;
    }


}
