package org.jeecg.modules.ctop.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.ctop.entity.*;
import org.jeecg.modules.ctop.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("template")
public class ByteDanceTemplateController {
    /**
     * 广告组模板
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("campaign/insert")
    public Map<String, Object> campaignTemplateInsert(@RequestBody ByteDanceCampaignTemplate template, HttpServletRequest req) {
        return campaignTemplateService.insertTemplate(template);
    }

    /**
     * 预算与出价模板
     *
     * @param template
     * @param request
     * @param response
     * @return
     */
    @PostMapping("budget/insert")
    public Map<String, Object> budgetTemplateInsert(@RequestBody ByteDanceBudgetTemplate template, HttpServletRequest request, HttpServletResponse response) {
        return budgetTemplateService.insertTemplate(template);
    }

    /**
     * 投放目标
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("deliverytarget/insert")
    public Map<String, Object> diliverytargetTemplateInsert(@RequestBody BytedanceDeliveryTargetTemplate template, HttpServletRequest req) {
        return deliveryTargetTemplateService.insertTemplate(template);
    }

    @GetMapping("deliveryTarget/get")
    public Map<String, Object> diliverytargetTemplateGet(Long targetId) {
        return deliveryTargetTemplateService.get(targetId);
    }
    /**
     * 广告创意创建
     *
     * @param template
     * @return
     */
    @PostMapping("creative/insert")
    public Map<String, Object> creativeInsert(@RequestBody JSONObject template) {
//        String s = "{\"verticalImageCreativeText\":\"\",\"convertId\":1637381304115207,\"verticalVideoCoverImageUrl\":\"//ctop-media.oss-cn-beijing.aliyuncs.com/0304%E4%BC%8A%E5%AF%B9-%E5%AD%94%E5%87%A1%20%E5%AD%99%E5%B2%A9%202%E7%AB%96%E7%89%88%E5%B0%81%E9%9D%A20-1565344790192.jpg\",\"creativeDisplayMode\":\"CREATIVE_DISPLAY_MODE_CTR\",\"horizonImageUrl\":\"\",\"sceneInventory\":\"VIDEO_SCENE\",\"horizonVideoUrl\":\"\",\"groupImageCreativeText\":\"\",\"userorentationId\":\"0\",\"isCommentDisable\":\"1\",\"horizonVideoCoverImageUrl\":\"\",\"deliveryRange\":\"DEFAULT\",\"planId\":\"\",\"horizonImageCreativeText\":\"\",\"verticalVideoUrl\":\"//ctop-media.oss-cn-beijing.aliyuncs.com/%E9%AB%98%E6%B8%85%E7%89%882-1565344662650.mp4\",\"inventoryType\":[\"INVENTORY_HOTSOON_FEED\",\"INVENTORY_AWEME_FEED\"],\"iteratorNum\":10,\"smallImageUrl\":\"\",\"verticalImageUrl\":\"\",\"campaignId\":1,\"smallImageCreativeText\":\"\",\"appName\":\"伊对\",\"groupImageUrl\":\"\",\"budgetId\":1,\"deliverytargetId\":1,\"adCategory\":[\"1907\",\"190710\",\"19071001\"],\"verticalVideoCreativeText\":\"{区县}离异再婚群，看对方信息不要钱！\",\"accountId\":111463131228,\"horizonVideoCreativeText\":\"\",\"advertiseLocation\":\"media\",\"creativeType\":\"customize\",\"adKeywords\":[\"伊对\",\"百合网\",\"相亲\",\"交友\",\"陌陌\",\"探探\",\"约会\",\"陌生人\",\"附近的人\",\"美女\",\"性感\",\"诱惑\",\"约炮\",\"开房\",\"单身\"],\"webUrl\":\"https://www.chengzijianzhan.com/tetris/page/6721972091068874760/\",\"name\":\"09-视频-珊珊自述-8.9\"}";
//        JSONObject getTemplate = JSONObject.parseObject(s);
        return creativeService.insertBatch(template);
    }

    @Autowired
    private IByteDanceCreativeService creativeService;

    @PostMapping(value = "allocation/list")
    public Result<IPage<UserAllocation>> queryPageList(@RequestBody UserAllocation userAllocation,
                                                       @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                       @RequestParam(name = "pageSize", defaultValue = "100") Integer pageSize,
                                                       HttpServletRequest req) {
        Result<IPage<UserAllocation>> result = new Result<>();
        QueryWrapper<UserAllocation> queryWrapper = QueryGenerator.initQueryWrapper(userAllocation, req.getParameterMap());
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        queryWrapper.eq("user_id", user.getId());
        Page<UserAllocation> page = new Page<>(pageNo, pageSize);
        IPage<UserAllocation> pageList = userAllocationService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    @Autowired
    private IUserAllocationService userAllocationService;

    /**
     * 用户定向
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("userorentation/insert")
    public Map<String, Object> userOrentationTemplateInsert(@RequestBody ByteDanceUserOrientationTemplate template, HttpServletRequest req) {
        return orientationTemplateService.insertTemplate(template);
    }

    /**
     * 链接信息
     *
     * @param urlInfo
     * @param req
     * @return
     */
    @PostMapping("link/insert")
    public Map<String, Object> linkInsert(@RequestBody BytedanceUrlInfo urlInfo, HttpServletRequest req) {
        return urlInfoService.insertLink(urlInfo);
    }

    @Autowired
    private IBytedanceUrlInfoService urlInfoService;
    /**
     * 广告计划模板
     *  方法废弃
     * @param template
     * @param req
     * @return
     */
    @PostMapping("advertiserplan/insert")
    public Map<String, Object> advertiserplanTemplateInsert(@RequestBody BytedanceAdvertisePlanTemplate template, String accountId, HttpServletRequest req) {
        return advertisePlanTemplateService.insertTemplate(template, accountId);
    }

    /**
     * 用户定向模板列表
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("userorentation/list")
    public Result<IPage<ByteDanceUserOrientationTemplate>> userOrentationTemplateList(ByteDanceUserOrientationTemplate template, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
        return orientationTemplateService.getList(template, pageNo, pageSize, req);
    }

    /**
     * 预算与出价模板
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("budget/list")
    public Result<IPage<ByteDanceBudgetTemplate>> budgetTemplateList(ByteDanceBudgetTemplate template, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
        return budgetTemplateService.getList(template, pageNo, pageSize, req);
    }

    /**
     * 广告组模板
     *
     * @return
     */
    @PostMapping("campaign/list")
    public Result<IPage<ByteDanceCampaignTemplate>> campaignTemplateList(ByteDanceCampaignTemplate template, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
        return campaignTemplateService.getList(template, pageNo, pageSize, req);
    }

    /**
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     * @功能：获取广告组列表信息
     */
    @PostMapping(value = "campaign/data/list")
    public Result<IPage<ByteDanceCampaign>> campaignPageList(@RequestBody ByteDanceCampaign campaign, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                             @RequestParam(name = "pageSize", defaultValue = "1000") Integer pageSize, HttpServletRequest req) {
        Result<IPage<ByteDanceCampaign>> result = new Result<>();
        QueryWrapper<ByteDanceCampaign> queryWrapper = QueryGenerator.initQueryWrapper(campaign, req.getParameterMap());
        queryWrapper.eq("toutiao_id", campaign.getToutiaoId()).orderByAsc("id");
        Page<ByteDanceCampaign> page = new Page<>(pageNo, pageSize);
        IPage<ByteDanceCampaign> pageList = campaignService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * @param accountId
     * @return 查询计划可用转化id
     */
    @GetMapping(value = "convert/list")
    public Map<String, Object> convertPageList(Long accountId, Long targetId) {
        return planService.getAdConvertList(accountId, targetId);
    }

    /**
     * @param req
     * @return
     * @功能：获取头条行业信息列表
     */
    @GetMapping(value = "/bytedance/industry/list")
    public JSONArray campaignPageList(HttpServletRequest req) {
        return fileInfoService.getByteDanceIndustryList(req);
    }

    @Autowired
    private IFileInfoService fileInfoService;

    /**
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     * @功能：获取广告计划列表信息
     */
    @PostMapping(value = "plan/data/list")
    public Result<IPage<ByteDanceAdvertisePlan>> planPageList(@RequestBody ByteDanceAdvertisePlan plan, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                              @RequestParam(name = "pageSize", defaultValue = "1000") Integer pageSize, HttpServletRequest req) {
        Result<IPage<ByteDanceAdvertisePlan>> result = new Result<>();
        QueryWrapper<ByteDanceAdvertisePlan> queryWrapper = QueryGenerator.initQueryWrapper(plan, req.getParameterMap());
        queryWrapper.eq("toutiao_id", plan.getToutiaoId()).orderByDesc("id");
        Page<ByteDanceAdvertisePlan> page = new Page<>(pageNo, pageSize);
        IPage<ByteDanceAdvertisePlan> pageList = planService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    @Autowired
    private IByteDanceAdvertisePlanService planService;
    @Autowired
    private IByteDanceCampaignService campaignService;

    /**
     * 投放目标
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("deliverytarget/list")
    public Result<IPage<BytedanceDeliveryTargetTemplate>> diliverytargetTemplateList(BytedanceDeliveryTargetTemplate template, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
        return deliveryTargetTemplateService.getList(template, pageNo, pageSize, req);
    }

    @PostMapping("video/upload")
    public Map<String, Object> videoUpload(MultipartFile file) {
        return new HashMap<>();
    }

    /**
     * 获取建站列表信息
     */
    @GetMapping("site/list")
    public JSONObject getSiteList(Long accountId) {
        return deliveryTargetTemplateService.getSiteList(accountId);
    }
    @Autowired
    private IByteDanceUserOrientationTemplateService orientationTemplateService;
    @Autowired
    private IByteDanceCampaignTemplateService campaignTemplateService;
    @Autowired
    private IByteDanceBudgetTemplateService budgetTemplateService;
    @Autowired
    private IBytedanceDeliveryTargetTemplateService deliveryTargetTemplateService;
    @Autowired
    private IBytedanceAdvertisePlanTemplateService advertisePlanTemplateService;

}
