package org.jeecg.modules.ctop.controller;

import com.alibaba.fastjson.JSONObject;
import org.jeecg.modules.ctop.service.IReportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RestController
@RequestMapping("report")
public class ReportController {
    @GetMapping("advertiser")
    public Map<String, Object> advertiserReport(String accountId, String startDate, String endDate, String timeGranularity) {
        return reportService.getAdvertiserReport(accountId, startDate, endDate, timeGranularity);
    }

    @GetMapping("campaign")
    public Map<String, Object> campaignReport(@RequestBody JSONObject conditions) {
        return reportService.getCampaignReport(conditions);
    }

    @Autowired
    private IReportService reportService;
}
