package org.jeecg.modules.ctop.service.impl;

import cn.com.ctop.common.utils.Check;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.jeecg.modules.ctop.entity.BindAccountLogin;
import org.jeecg.modules.ctop.mapper.BindAccountLoginMapper;
import org.jeecg.modules.ctop.service.IBindAccountLoginService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 账号绑定-登陆
 * @Author: jeecg-boot
 * @Date: 2019-07-31
 * @Version: V1.0
 */
@Service
public class BindAccountLoginServiceImpl extends ServiceImpl<BindAccountLoginMapper, BindAccountLogin> implements IBindAccountLoginService {
    private static final Logger logger = LoggerFactory.getLogger(BindAccountLoginServiceImpl.class);

    @Autowired
    private BindAccountLoginMapper bindAccountLoginMapper;

    @Override
    public boolean bindLogin(String advertiserId, String accountName, String password, String loginType) {
        Map<String, Object> requestMap = new HashMap<>();
        requestMap.put("advertiser_id", advertiserId);
        requestMap.put("account_name", accountName);
        requestMap.put("login_type", loginType);
        List<BindAccountLogin> bindAccounts = bindAccountLoginMapper.selectByMap(requestMap);
        if (!Check.isNull(bindAccounts)) {
            return false;
        }
        BindAccountLogin bindAccountLogin = new BindAccountLogin();
        bindAccountLogin.setAdvertiserId(advertiserId);
        bindAccountLogin.setAccountName(accountName);
        bindAccountLogin.setPassword(password);
        bindAccountLogin.setLoginType(loginType);
        int i = bindAccountLoginMapper.insert(bindAccountLogin);
        if (i > 0) {
            logger.info("登录账号绑定成功，广告主id:{}", bindAccountLogin.getAdvertiserId());
            return true;
        }

        return false;
    }

}
