package org.jeecg.modules.ctop.service.impl;

import com.alibaba.fastjson.JSONObject;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpEntityEnclosingRequestBase;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.jeecg.modules.ctop.entity.CTopOauthToken;
import org.jeecg.modules.ctop.service.ICTopOauthTokenService;
import org.jeecg.modules.ctop.service.IReportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URI;
import java.util.HashMap;
import java.util.Map;

@Service
public class ReportServiceImpl implements IReportService {
    @Override
    public Map<String, Object> getAdvertiserReport(String accountId, String startDate, String endDate, String timeGranularity) {
        CTopOauthToken token = tokenService.getOAuthTokenByAccountId(accountId);
        JSONObject getObject = getAdvertiserStat(token, startDate, endDate, timeGranularity);
        return null;
    }

    @Override
    public Map<String, Object> getCampaignReport(JSONObject conditions) {
        return null;
    }

    @Autowired
    private ICTopOauthTokenService tokenService;

    public JSONObject getAdvertiserStat(CTopOauthToken token, String startDate, String endDate, String timeGranularity) {
        String accessToken = token.getAccessToken();
        final Long advertiserId = token.getAccountId();

        // 请求地址
        String url = "https://ad.toutiao.com/open_api/2/report/advertiser/get/";

        // 请求参数
        Map data = new HashMap() {
            {
                put("advertiser_id", advertiserId);
                put("start_date", startDate);
                put("end_date", endDate);
                put("time_granularity", timeGranularity);
            }
        };

        // 构造请求
        HttpEntityEnclosingRequestBase httpEntity = new HttpEntityEnclosingRequestBase() {
            @Override
            public String getMethod() {
                return "GET";
            }
        };

        httpEntity.setHeader("Access-Token", token.getAccessToken());

        CloseableHttpResponse response = null;
        CloseableHttpClient client = null;

        try {
            client = HttpClientBuilder.create().build();
            httpEntity.setURI(URI.create(url));
            httpEntity.setEntity(new StringEntity(JSONObject.toJSONString(data), ContentType.APPLICATION_JSON));

            response = client.execute(httpEntity);
            if (response != null && response.getStatusLine().getStatusCode() == 200) {
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(response.getEntity().getContent()));
                StringBuffer result = new StringBuffer();
                String line = "";
                while ((line = bufferedReader.readLine()) != null) {
                    result.append(line);
                }
                bufferedReader.close();
                return JSONObject.parseObject(result.toString());
            }

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (response != null) {
                    response.close();
                }
                client.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return null;
    }
}
